<template>
  <div class="base-select"
       :class="{
          'base-select--selected': selected,
          'base-select--error': error,
       }"
  >
    <v-select class="base-select__plugin"
              :clearable="false"
              :searchable="false"
              :options="options"
              v-model="selected"
              @search:focus="selectOpened"
              @search:blur="selectClosed"
    >
      <span slot="no-options">{{ noOptionsText }}</span>
      <template #open-indicator="{ attributes }">
        <span v-bind="attributes">
          <icon-small-arrow />
        </span>
      </template>
    </v-select>

    <span class="base-select__label">{{ label }}</span>
  </div>

</template>

<script>
  import IconSmallArrow from './icons/IconSmallArrow';

  export default {
    name: 'BaseSelect',
    components: {
      IconSmallArrow
    },
    props: {
      options: {
        type: Array,
        required: true
      },

      label: {
        type: String,
        required: true
      },

      error: {
        type: Boolean,
        default: false,
      },

      value: {
        type: [String, Number],
        required: false
      },

      noOptionsText: {
        type: String,
        default: 'Ничего не найдено'
      }
    },
    data: () => ({
      selected: null
    }),
    mounted() {
      this.$nextTick(() => {
        if (this.value) {
          this.selected = this.options
            .filter((option) => this.filterType(option) === this.value)[0];
        }
      });
    },
    watch: {
      selected(val, newVal) {
        if (val && newVal && this.filterType(val) === this.filterType(newVal)) return;

        if (!this.selected)
          this.selected = this.options
            .filter((option) => this.filterType(option) === this.value)[0];

        if (this.selected) {
          this.$emit('onSelect', this.selected);
        }
      },

      value() {
        if (this.value) {
          this.$nextTick(() => {
            this.selected = this.options
              .filter((option) => this.filterType(option) === this.value)[0];
          });

        }
      },

      options() {
        this.selected = this.options
          .filter((option) => this.filterType(option) === this.value)[0];
      }
    },
    methods: {
      filterType(option) {
        return typeof option === 'object' ? option.value : option
      },
      selectOpened() {
        this.$el.style.zIndex = '5';
      },
      selectClosed() {
        this.$el.style.zIndex = '';
      }
    }
  }
</script>

<style lang="scss">
  @import 'vue-select/src/scss/vue-select.scss';

  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .base-select {
    z-index: 1;
    height: rem(70);

    &--selected {
      .base-select__plugin:not(.vs--open) {
        .vs__dropdown-toggle {
          border-color: rgba($green, .5);
        }
      }

      .base-select__label {
        @include p3;
        color: rgba($black, .6);

        position: absolute;
        top: rem(12);
        transform: none;
      }
    }

    &--error {
      .base-select__plugin:not(.vs--open) {
        .vs__dropdown-toggle {
          border-color: $red;
        }
      }

      .base-select__label {
        color: rgba($red, .6);
      }

      .vs__open-indicator {
        svg {
          stroke: rgba($red, .6);
        }
      }
    }

    &__label {
      @include p1;
      color: rgba($black, .4);

      position: absolute;
      left: rem(30);
      top: 50%;
      transform: translateY(-50%);

      transition: all .25s;
    }

    &__plugin {
      .vs__dropdown-toggle {
        width: 100%;
        height: rem(70);
        padding: 0 rem(28);

        border: rem(2) solid #DCE2EF;
        border-radius: rem(4);

        .vs__selected-options {
          padding: 0;
          max-width: calc(100% - 0.75rem);

          .vs__selected {
            max-width: 100%;
            overflow: hidden;
            text-overflow: ellipsis;
            white-space: nowrap;
          }
        }

        .vs__actions {
          padding: 0;

        }

        .vs__open-indicator {
          svg {
            width: rem(10);
            height: rem(8);
          }
        }

        .vs__selected {
          @include p1;

          top: rem(30);

          display: block;
          height: rem(24);
          margin: 0;
          padding: 0;

          opacity: 1;
          border: none;
        }
      }

      .vs__dropdown-menu {
        position: static;

        padding: 0;
        max-height: rem(216);
        min-width: auto;

        border: none;
        box-shadow: none;
        background: transparent;

        .vs__dropdown-option {
          @include p1;

          padding: rem(24) rem(28);

          color: $dark-gray;
          white-space: initial;

          b {
            color: $black;
          }

          &--highlight {
            background: transparent;
          }
        }
      }

      &.vs--open {
        background: linear-gradient(172.9deg, #F5F8FB 0%, #FFFFFF 100%);
        box-shadow: 0 rem(20) rem(30) rgba(24, 46, 68, 0.16);
        border-radius: rem(8);

        .vs__dropdown-toggle {
          border: none;

          .vs__selected-options {
            border-bottom: rem(1) solid #DCE2EF;
          }
        }

        .vs__selected {
          top: rem(32);
          left: rem(2);
        }
      }

      .vs__dropdown-option--selected {
        display: none;
      }
    }

  }
</style>
